var loadingView = (function () {
    function loadingView() {
        this.sOS = conchConfig.getOS();
        if (this.sOS == "Conch-ios") {
            this.bridge = PlatformClass.createClass("JSBridge");
        }
        else if (this.sOS == "Conch-android") {
            this.bridge = PlatformClass.createClass("game.JSBridge");
        }
    }
    Object.defineProperty(loadingView.prototype, "loadingAutoClose", {
        get: function () {
            return this._loadingAutoClose;
        },
        set: function (value) {
            this._loadingAutoClose = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(loadingView.prototype, "showTextInfo", {
        get: function () {
            return this._showTextInfo;
        },
        set: function (value) {
            this._showTextInfo = value;
            if (this.bridge) {
                if (this.sOS == "Conch-ios") {
                    this.bridge.call("showTextInfo:", value);
                }
                else if (this.sOS == "Conch-android") {
                    this.bridge.call("showTextInfo", value);
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    loadingView.prototype.bgColor = function (value) {
        if (this.bridge) {
            if (this.sOS == "Conch-ios") {
                this.bridge.call("bgColor:", value);
            }
            else if (this.sOS == "Conch-android") {
                this.bridge.call("bgColor", value);
            }
        }
    };
    loadingView.prototype.setFontColor = function (value) {
        if (this.bridge) {
            if (this.sOS == "Conch-ios") {
                this.bridge.call("setFontColor:", value);
            }
            else if (this.sOS == "Conch-android") {
                this.bridge.call("setFontColor", value);
            }
        }
    };
    loadingView.prototype.setTips = function (value) {
        if (this.bridge) {
            if (this.sOS == "Conch-ios") {
                this.bridge.call("setTips:", value);
            }
            else if (this.sOS == "Conch-android") {
                this.bridge.call("setTips", value);
            }
        }
    };
    loadingView.prototype.loading = function (value) {
        if (this.bridge) {
            if (this.sOS == "Conch-ios") {
                this.bridge.call("loading:", value);
            }
            else if (this.sOS == "Conch-android") {
                this.bridge.call("loading", value);
            }
        }
    };
    loadingView.prototype.hideLoadingView = function () {
        this.bridge.call("hideSplash");
    };
    return loadingView;
}());

window.loadingView = new loadingView();
if(window.loadingView)
{
    window.loadingView.loadingAutoClose=false;//true代表当动画播放完毕，自动进入游戏。false为开发者手动控制
    window.loadingView.bgColor("#1d1f3f");//设置背景颜色
    window.loadingView.setFontColor("#000000");//设置字体颜色
    window.loadingView.setTips([""]);//设置tips数组，会随机出现
}
window.onLayaInitError=function(e)
{
	console.log("onLayaInitError error=" + e);
    var _sOS = conchConfig.getOS();
    var _bridge;
    if (_sOS == "Conch-ios") {
        _bridge= PlatformClass.createClass("JSBridge");
        _bridge.call("onLayaInitError:");
    }
    else if (_sOS == "Conch-android") {
        _bridge = PlatformClass.createClass("game.JSBridge");
        _bridge.call("onLayaInitError");
    }
	//alert("加载游戏失败，可能由于您的网络不稳定，请退出重进");
}

//layanative有bug，config.js在覆盖安装的时候用户修改的这个config.js会被包里的覆盖掉，所以以下代码要在JSBridge里面重新执行一遍。
window.ConchRenderType= 5; //6 WebGL 5 openGL
//在这进行设定
//atlasNum 大图集合的数量，每张4M*30=120M（推荐是maxTextureMemSize的1/4？毕竟我们小图片没那么多）
//maxTextureMemSize大图和大图集合的总显存400M
var nMem = conchConfig.getTotalMem();
if (nMem > 3.5*1024 * 1024) {
    conchConfig.atlasNum = 30;
    conchConfig.maxTextureMemSize =  400 * 1024 * 1024;
}
else if (nMem > 3*1024 * 1024) {
    conchConfig.atlasNum = 28;
    conchConfig.maxTextureMemSize =  380 * 1024 * 1024;
}
else if (nMem > 2.5*1024 * 1024) {
    conchConfig.atlasNum = 26;
    conchConfig.maxTextureMemSize = 320 * 1024 * 1024;
}
else if (nMem > 2*1024 * 1024) {
    conchConfig.atlasNum = 24;
    conchConfig.maxTextureMemSize = 300 * 1024 * 1024;
}
else if (nMem > 1.5*1024 * 1024) {
    conchConfig.atlasNum = 22;
    conchConfig.maxTextureMemSize = 230 * 1024 * 1024;
}
else if (nMem > 1024 * 1024) {
    conchConfig.atlasNum = 20;
    conchConfig.maxTextureMemSize = 160 * 1024 * 1024;
}
else if (nMem >0.5* 1024 * 1024) {
    conchConfig.atlasNum = 18;
    conchConfig.maxTextureMemSize = 128 * 1024 * 1024;
}
else{
    conchConfig.atlasNum = 16;
    conchConfig.maxTextureMemSize = 84 * 1024 * 1024;
}

console.log("mem:" + conchConfig.maxTextureMemSize+"/"+nMem+" atlasNum"+conchConfig.atlasNum+" window.ConchRenderType"+window.ConchRenderType);